
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
//#include <pari/pari.h>
#include "automate.h"

#define MAC	true

void Etat::init ()
{
	a = NULL;
	n = 0;
	final = false;
}

void Arete::init ()
{
	e = 0;
	c = 0;
}

void Etat::New (ui n2)
{
	n = n2;
	a = (Arete *)malloc(sizeof(Arete)*n);
	ui i;
	for (i=0;i<n;i++)
	{
		a[i].init();
	}
}
void Etat::New (Etat e)
{
	n = e.n;
	a = (Arete *)malloc(sizeof(Arete)*n);
	ui i;
	for (i=0;i<n;i++)
	{
		a[i] = e.a[i];
	}
}
void Etat::Del ()
{
	free(a);
}

void Automate::New (ui n2)
{
	n = n2;
	e = (Etat *)malloc(sizeof(Etat)*n);
	if (!e)
	{
		fprintf(stderr, "Impossible d'allouer l'automate !\n");
		return;
	}
	ui i;
	for (i=0;i<n;i++)
	{
		e[i].init();
	}
	ef = n-1;
}

void Automate::Del ()
{
	free(e);
}

void Automate::Save_FSM ()
{
	FILE *f = fopen("A.txt", "w+");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	ui i,j;
	for (i=0;i<n;i++)
	{
		for (j=0;j<e[i].n;j++)
		{
			if (e[i].a[j].e != -1)
				fprintf(f, "%d	%d	%c\n", i, e[i].a[j].e, e[i].a[j].c);
		}
	}
	
	fprintf(f, "%d\n", ef); //état final
	
	fclose(f);
}

void Automate::Save_FSM (bool *s)
{
	FILE *f = fopen("A.txt", "w+");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	ui i,j;
	for (i=0;i<n;i++)
	{
		if (s[i])
		{
			for (j=0;j<e[i].n;j++)
			{
				if (e[i].a[j].e != -1 && s[e[i].a[j].e])
					fprintf(f, "%d	%d	%c\n", i, e[i].a[j].e, e[i].a[j].c);
			}
		}
	}
	
	fprintf(f, "%d\n", ef); //état final
	
	fclose(f);
}

void Automate::Save_FSM2 ()
{
	FILE *f = fopen("A.txt", "w+");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	ui i,j;
	for (i=0;i<n;i++)
	{
		for (j=0;j<e[i].n;j++)
		{
			if (e[i].a[j].e != -1)
			{
				//char tamp[10];
				switch (e[i].a[j].c)
				{
					case '0':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(0,b)");
						break;
					case '1':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(1,b)");
						break;
					case '2':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(0,1)");
						break;
					case '3':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(0,0)");
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(1,1)");
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(b,b)");
						break;
					case '4':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(1,0)");
						break;
					case '5':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(b,1)");
						break;
					case '6':
						fprintf(f, "%d	%d	%s\n", i, e[i].a[j].e, "(b,0)");
						break;
				}				
			}
		}
	}
	
	fprintf(f, "%d\n", ef); //état final
	
	fclose(f);
}

void Automate::Save_FSM3 ()
{
	FILE *f = fopen("A.txt", "w+");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	ui i,j;
	for (i=0;i<n;i++)
	{
		for (j=0;j<e[i].n;j++)
		{
			if (e[i].a[j].e != -1)
			{
				//char tamp[10];
				int a = 3;
				int b = 7;
				switch (e[i].a[j].c)
				{
					case '0':
						fprintf(f, "%d	%d	(%d,%d)\n", i, e[i].a[j].e, a, b);
						break;
					case '1':
						fprintf(f, "%d	%d	(%d,0)\n", i, e[i].a[j].e, a);
						break;
					case '2':
						fprintf(f, "%d	%d	(0,%d)\n", i, e[i].a[j].e, b);
						break;
					case '3':
						fprintf(f, "%d	%d	(0,0)\n", i, e[i].a[j].e);
						fprintf(f, "%d	%d	(%d,%d)\n", i, e[i].a[j].e, a, a);
						fprintf(f, "%d	%d	(%d,%d)\n", i, e[i].a[j].e, b, b);
						break;
					case '4':
						fprintf(f, "%d	%d	(%d,0)\n", i, e[i].a[j].e, b);
						break;
					case '5':
						fprintf(f, "%d	%d	(0,%d)\n", i, e[i].a[j].e, a);
						break;
					case '6':
						fprintf(f, "%d	%d	(%d,%d)\n", i, e[i].a[j].e, b, a);
						break;
				}				
			}
		}
	}
	
	fprintf(f, "%d\n", ef); //état final
	
	fclose(f);
}

void Automate::Save_FSM4 ()
{
	FILE *f = fopen("A.txt", "w+");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	ui i,j;
	for (i=0;i<n;i++)
	{
		for (j=0;j<e[i].n;j++)
		{
			if (e[i].a[j].e != -1)
			{
				switch (e[i].a[j].c)
				{
					case '0':
						fprintf(f, "%d	%d	(p,q)\n", i, e[i].a[j].e);
						break;
					case '1':
						fprintf(f, "%d	%d	(p,0)\n", i, e[i].a[j].e);
						break;
					case '2':
						fprintf(f, "%d	%d	(0,q)\n", i, e[i].a[j].e);
						break;
					case '3':
						fprintf(f, "%d	%d	(0,0)\n", i, e[i].a[j].e);
						fprintf(f, "%d	%d	(p,p)\n", i, e[i].a[j].e);
						fprintf(f, "%d	%d	(q,q)\n", i, e[i].a[j].e);
						break;
					case '4':
						fprintf(f, "%d	%d	(q,0)\n", i, e[i].a[j].e);
						break;
					case '5':
						fprintf(f, "%d	%d	(0,p)\n", i, e[i].a[j].e);
						break;
					case '6':
						fprintf(f, "%d	%d	(q,p)\n", i, e[i].a[j].e);
						break;
				}				
			}
		}
	}
	
	fprintf(f, "%d\n", ef); //état final
	
	fclose(f);
}

void Automate::Load_FSM ()
{
	FILE *f = fopen("A.txt", "r");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	//compte le nombre d'états
	n = 0;
	ui i;
	int e1, e2;
	int co;
	char str[100];
	for (i=0;;i++)
	{
		//fscanf(f, "%s", str);
		//printf("%s\n", str);
		//if (!fscanf(f, "%d", &e))
		//	break;
		if (!fgets(str, 100, f))
			break;
		co = sscanf(str, "%d %d", &e1, &e2);
		if (co == 1)
		{
			ef = e1;
		}
		/*if (!c)
		{
			printf("Erreur : la ligne %d ne commence pas par un nombre.\n", i);
		}*/
		//printf("%d", e);
		if (feof(f))
			break;
		if (e1+1 > n)
		{
			n = e1+1;
		}
		if (co >= 2)
		{
			//printf("	%d", e2);
			if (e2+1 > n)
			{
				n = e2+1;
			}
		}
		//printf("\n");
	}
	//alloue les etats
	printf("%d etats.\n", n);
	New(n);
	//compte le nombre d'aretes
	rewind(f);
	for (i=0;;i++)
	{
		if (!fgets(str, 100, f))
			break;
		co = sscanf(str, "%d", &e1);
		if (feof(f))
			break;
		if (co > 0)
			e[e1].n++;
	}
	//alloue les aretes
	for (i=0;i<n;i++)
	{
		e[i].New(e[i].n);
		e[i].n = 0;
	}
	//enregistre le graphe
	rewind(f);
	char c;
	for (i=0;;i++)
	{
		if (!fgets(str, 100, f))
			break;
		co = sscanf(str, "%d %d %c", &e1, &e2, &c);
		if (co >= 3)
		{
			//ajoute l'arete e1 -c-> e2
			e[e1].a[e[e1].n].e = e2;
			e[e1].a[e[e1].n].c = c;
			e[e1].n++;
		}
	}
	
	fclose(f);
}

void Automate::Load_FSM (int ar) //automate d'arité ar
{
	FILE *f = fopen("A.txt", "r");
	if (!f)
	{
		fprintf(stderr, "Impossible d'ouvrir le fichier A.txt\n");
		return;
	}
	
	//compte le nombre d'états
	n = 0;
	ui i;
	int e1, e2;
	int co;
	char str[100];
	for (i=0;;i++)
	{
		//fscanf(f, "%s", str);
		//printf("%s\n", str);
		//if (!fscanf(f, "%d", &e))
		//	break;
		if (!fgets(str, 100, f))
			break;
		co = sscanf(str, "%d %d", &e1, &e2);
		if (co == 1)
		{
			ef = e1;
		}
		/*if (!c)
		{
			printf("Erreur : la ligne %d ne commence pas par un nombre.\n", i);
		}*/
		//printf("%d", e);
		if (feof(f))
			break;
		if (e1+1 > n)
		{
			n = e1+1;
		}
		if (co >= 2)
		{
			//printf("	%d", e2);
			if (e2+1 > n)
			{
				n = e2+1;
			}
		}
		//printf("\n");
	}
	//alloue les etats
	printf("%d etats.\n", n);
	New(n);
	//alloue les aretes
	for (i=0;i<n;i++)
	{
		e[i].New(ar);
		e[i].n = ar;
	}
	//enregistre le graphe
	rewind(f);
	char c;
	for (i=0;;i++)
	{
		if (!fgets(str, 100, f))
			break;
		co = sscanf(str, "%d %d %c", &e1, &e2, &c);
		if (co >= 3)
		{
			if (c-'0' >= ar || c-'0' < 0)
			{
				printf("Erreur : numéro d'arete incorrect %c >%d ou <0.\n", c, ar);
			}
			//ajoute l'arete e1 -c-> e2
			e[e1].a[c-'0'].e = e2;
			e[e1].a[c-'0'].c = c;
		}
	}
	
	fclose(f);
}

bool Automate::Rec (int *m, int l) //détermine si le mot est reconnu ou non par l'automate
{
	int i;
	int ce = 0;
	for (i=0;i<l;i++)
	{
		ce = e[ce].a[m[i]].e;
	}
	return (ce == ef);
}

void Automate::disp_matrice (bool nob)
{
	int i,j,k;
	int c = 0;
	printf("factor(charpoly([");
	for (i=0;i<n;i++)
	{
		if (i)
			printf(";");
		for (j=0;j<n;j++)
		{
			if (j)
				printf(",");
			c = 0;
			if (nob)
			{
				for (k=0;k<2;k++)
				{
					if (e[i].a[k].e == j)
					{
						c++;
					}
				}
			}else
			{
				for (k=0;k<3;k++)
				{
					if (e[i].a[k].e == j)
					{
						c++;
					}
				}
			}
			printf("%d", c);
		}
	}
	printf("]))\n");
	/*
	printf("factor(charpoly([");
	for (i=0;i<n;i++)
	{
		if (i)
			printf(", ");
		printf("[");
		for (j=0;j<n;j++)
		{
			if (j)
				printf(", ");
			c = 0;
			for (k=0;k<3;k++)
			{
				if (e[i].a[k].e == j)
				{
					c++;
				}
			}
			printf("%d", c);
		}
		printf("]");
	}
	printf("], x));\n");
	*/
}

/*
GEN Automate::get_PARI () //retourne la matrice au format de Pari
{
	GEN m;
	int i,j,k;
	int c;
	m = cgetg(n+1, t_MAT);
	for(i=1; i<n+1; i++)
	{
		gel(m, i) = cgetg(n+1, t_COL);
		for (j=1;j<n+1;j++)
		{
			c = 0;
			for (k=0;k<e[i-1].n;k++)
			{
				if (e[i-1].a[k].e == j-1)
					c++;
			}
			gel(gel(m,i),j) = utoi(c);
		}
	}
	return m;
}
*/

void Automate::Parcours (bool *s, int i)
{
	if (!s[i])
	{
		s[i] = true;
		int j;
		for (j=0;j<e[i].n;j++)
		{
			Parcours(s, e[i].a[j].e);
		}
	}
}

bool *Automate::Emonde () //supprimme les états qui ne servent à rien (i.e. qui n'aboutissent pas à un état final ou ne sont pas accessibles)
{
	bool *s = (bool *)malloc(sizeof(bool)*n);
	bool *s2 = (bool *)malloc(sizeof(bool)*n);
	int i, j, a;
	bool mod;
	printf("Etats co-accessibles...\n");
	//retire les états non co-accessibles
	for (i=0;i<n;i++)
	{
		s[i] = true;
	}
	do
	{
		mod = false;
		for (i=0;i<n;i++)
		{
			if (s[i])
			{
				a = 0; //compte les arêtes valides
				for (j=0;j<e[i].n;j++)
				{
					if (s[e[i].a[j].e])
					{
						a++;
					}
				}
				if (!a)
				{
					s[i] = false; //aucune arête ne part de ce sommet
					mod = true;
				}
			}
		}
	}while(mod);
	
	for (i=0;i<n;i++)
	{
		if (s[i])
		{
			printf("%d ", i);
		}
	}
	printf("\n");
	
	//retire les états non accessibles
	printf("Etats accessibles...\n");
	for (i=0;i<n;i++)
	{
		s2[i] = false;
	}
	Parcours(s2, 0);
	
	for (i=0;i<n;i++)
	{
		if (s2[i])
		{
			printf("%d ", i);
		}
	}
	printf("\n");
	
	
	
	/*
	//retire les sommets à retirer
	int dec = 0, dec2;
	for (i=0;i<n;i++)
	{
		while (!s[i] || !s2[i])
		{
			dec++;
			e[i] = e[i+dec];
			s[i] = s[i+dec];
			s2[i] = s2[i+dec];
			n--;
		}
		//retire les arêtes vers les sommets retirés
		dec2 = 0;
		for (j=0;j<e[i].n;j++)
		{
			if (!s[e[i].a[j].e] || !s2[e[i].a[j].e])
			{
				dec2++;
				e[i].n--;
			}
			if (dec)
				e[i].a[j] = e[i].a[j+dec2];
		}
	}
	*/
	//free(s);
	free(s2);
	for (i=0;i<n;i++)
	{
		s[i] = s[i] && s2[i];
	}
	
	printf("Etats restants...\n");
	for (i=0;i<n;i++)
	{
		if (s[i])
		{
			printf("%d ", i);
		}
	}
	printf("\n");
	
	return s;
}

/*
void Automate::Emonde () //supprimme les états qui ne servent à rien (i.e. qui n'aboutissent pas à un état final)
{
	int *t = (int *)malloc(sizeof(int)*n);
	int i,j,k;
	for (i=0;i<n;i++)
	{
		t[i] = 0; //l'etat n'est à priori pas cofinal
	}
	
	e[ef].final = true; //pour être sûr
	for (i=0;i<n;i++)
	{
		if (e[i].final)
		{
			t[i] = 1;
		}
	}
	
	int c = 1;
	int rc = c;
	for (;;)
	{
		for (i=0;i<n;i++)
		{
			if (!t[i])
			{
				for (j=0;j<e[i].n;j++)
				{
					if (e[i].a[j].e != -1)
					{
						if (t[e[i].a[j].e])
						{
							t[i] = 1;
							//printf("i = %d\n", i);
							c++;
							break;
						}
					}
				}
			}
		}
		if (c == rc)
			break;
		rc = c;
	}
	printf("c = %d (n = %d)\n", c, n);
	//supprimme les sommets non cofinaux
	c = 0;
	for (i=0;i<n;i++)
	{
		if (t[i])
		{
			//remplace tous les sommets i par des sommets c
			for (j=0;j<n;j++)
			{
				for (k=0;k<e[j].n;k++)
				{
					if (e[j].a[k].e == i)
					{
						e[j].a[k].e = c;
					}
					//
					//if (e[j].a[k].e != -1)
					//{
					//	if (!t[e[j].a[k].e])
					//		e[j].a[k].e = -1;
					//}
					//
				}
			}
			e[c] = e[i];
			c++;
		}else
		{
			//éfface tous les sommets i
			for (j=0;j<n;j++)
			{
				for (k=0;k<e[j].n;k++)
				{
					if (e[j].a[k].e == i)
					{
						e[j].a[k].e = -1;
					}
				}
			}
		}
	}
	n = c;
	free(t);
}
*/

bool *Automate::Emonde0 () //supprimme les états qui ne servent à rien en interdisant les arêtes 0 (i.e. qui n'aboutissent pas à un état final)
{
	int i, j;
	int dec; //décalage à faire
	for (i=0;i<n;i++)
	{
		dec = 0;
		for (j=0;j<e[i].n;j++)
		{
			if (e[i].a[j].c == '0')
			{
				dec++;
				e[i].n--;
			}
			if (dec)
				e[i].a[j] = e[i].a[j+dec];
		}
	}
	return Emonde();
}



