#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
//#include <pari/pari.h>
#include "automate.h"
#include "main.h"

#define MAC true

bool letat = true; //met les labels sur les états
bool div2 = false; //divise par deux les labels des aretes

struct Photo
{
	bool *b;
	int h;
	
	void New (int n);
	void Del ();
	//
	void init (int nb); //position de départ avec nb balles et hauteur au plus hm
	Photo next (int p); //photo suivante si l'on lance en p
	Photo next0 (); //photo suivante si l'on ne lance pas
	bool equal (Photo p2);
	//
	void fprint (FILE *f);
	void print ();
};

void Photo::New (int h2)
{
	h = h2;
	b = (bool *)malloc(sizeof(bool)*h);
}
void Photo::Del()
{
	free(b);
}
//
void Photo::init (int nb) //position de départ avec nb balles
{
	int i;
	for (i=0;i<nb;i++)
	{
		b[i] = true;
	}
	for (i=nb;i<h;i++)
	{
		b[i] = false;
	}
}
Photo Photo::next (int p) //photo suivante si l'on lance en p
{
	Photo r;
	r.New(h);
	int i;
	for (i=0;i<h-1;i++)
	{
		r.b[i] = b[i+1];
	}
	r.b[h-1] = false;
	r.b[p] = true;
	return r;
}
Photo Photo::next0 () //photo suivante si l'on ne lance rien
{
	Photo r;
	r.New(h);
	int i;
	for (i=0;i<h-1;i++)
	{
		r.b[i] = b[i+1];
	}
	r.b[h-1] = false;
	return r;
}
bool Photo::equal (Photo p2)
{
	if (p2.h < h)
		return p2.equal(*this);
	int i;
	for (i=0;i<h;i++)
	{
		if (b[i] != p2.b[i])
		{
			return false;
		}
	}
	for (i=h;i<p2.h;i++)
	{
		if (p2.b[i])
			return false;
	}
	return true;
}
//
void Photo::fprint (FILE *f)
{
	int i;
	for (i=h;i>0;i--)
	{
		if (b[i-1])
			fprintf(f, "o\\n");
		else
			fprintf(f, "-\\n");
	}
	//printf("\n");
}
void Photo::print ()
{
	fprint(stdout);
}

int binom (int a, int b) //calcule b parmi a
{
	int r = 1;
	int i;
	for (i=0;i<b;i++)
	{
		r = r*(a-i);
	}
	for (i=1;i<=b;i++)
	{
		r = r/i;
	}
	return r;
}

Automate a;
int pc; //photo courante
Photo *p;
int np = 0; //nombre de photos rencontrées
bool AddP (Photo p2, char c) //ajoute une photo à la liste si celle-ci n'existe pas déjà
{
	//printf("AddP ");
	//p2.print();
	//printf(" %c\n", c);
	int i;
	for (i=0;i<np;i++)
	{
		if (p[i].equal(p2))
		{
			a.e[pc].a[a.e[pc].n].e = i;
			a.e[pc].a[a.e[pc].n].c = c;
			a.e[pc].n++;
			return false;
		}
	}
	a.e[np].New(p2.h); //alloue les arêtes du nouvel état
	a.e[np].n = 0;
	a.e[pc].a[a.e[pc].n].e = np;
	a.e[pc].a[a.e[pc].n].c = c;
	a.e[pc].n++;
	p[np] = p2;
	printf("Nouvel etat : ");
	p2.print();
	printf("\n");
	np++;
	return true;
}

void SaveFSM ()
{
	FILE *f = fopen("A.dot", "w");
	if (!f)
	{
		printf("Impossible d'ouvrir le fichier A.dot !\n");
		return;
	}
	fprintf(f, "digraph FSM\n");
	fprintf(f, "{\n");
	fprintf(f, "	rankdir = LR;\n"); //TB
	//fprintf(f, "	size = \"8.5,11\";\n");
	fprintf(f, "	label = \"\";\n");
	fprintf(f, "	center = 1;\n");
	fprintf(f, "	nodesep = \"0.3\";\n");
	fprintf(f, "	ranksep = \"0.8\";\n");
	//fprintf(f, "	orientation = Landscape;\n");
	
	int i,j;
	for (i=0;i<a.n;i++)
	{
		if (letat)
		{
			fprintf(f, "	%d [label = \"", i);
			p[i].fprint(f);
			fprintf(f, "\", shape = box, width = .3, style = bold, fontsize = 14]\n"); // shape = ellipse, rectangle
		}else
		{
			fprintf(f, "	%d [label = \"\", shape = circle, width = .3]\n", i);
		}
		for (j=0;j<a.e[i].n;j++)
		{
			if (div2)
			{
				if ((a.e[i].a[j].c - '0')%2 == 0)
					fprintf(f, "		%d -> %d [label=\"%c\", fontsize = 14, arrowhead = open];\n", i, a.e[i].a[j].e, '0'+(a.e[i].a[j].c-'0')/2);
				else
					fprintf(f, "		%d -> %d [label=\"%c.5\", fontsize = 14, arrowhead = open];\n", i, a.e[i].a[j].e, '0'+(a.e[i].a[j].c-'0')/2);
			}else
				fprintf(f, "		%d -> %d [label=\"%c\", fontsize = 14, arrowhead = open];\n", i, a.e[i].a[j].e, a.e[i].a[j].c);
		}
	}
	
	fprintf(f, "}\n");
	fclose(f);
}

void SaveFSM (bool *s)
{
	FILE *f = fopen("A.dot", "w");
	if (!f)
	{
		printf("Impossible d'ouvrir le fichier A.dot !\n");
		return;
	}
	fprintf(f, "digraph FSM\n");
	fprintf(f, "{\n");
	fprintf(f, "	rankdir = LR;\n"); //TB
	//fprintf(f, "	size = \"8.5,11\";\n");
	fprintf(f, "	label = \"\";\n");
	fprintf(f, "	center = 1;\n");
	//fprintf(f, "	nodesep = \"0.5\";\n");
	//fprintf(f, "	ranksep = \"0.8\";\n");
	//fprintf(f, "	orientation = Landscape;\n");
	
	int i,j;
	for (i=0;i<a.n;i++)
	{
		if (s[i])
		{
			if (letat)
			{
				fprintf(f, "	%d [label = \"", i);
				p[i].fprint(f);
				fprintf(f, "\", shape = box, width = .3, style = bold, fontsize = 14]\n"); // shape = ellipse, rectangle
			}else
			{
				fprintf(f, "	%d [label = \"\", shape = circle, width = .3]\n", i);
			}
			for (j=0;j<a.e[i].n;j++)
			{
				if (s[a.e[i].a[j].e])
				{
					if (div2)
					{
						if ((a.e[i].a[j].c - '0')%2 == 0)
							fprintf(f, "		%d -> %d [label=\"%c\", fontsize = 14, arrowhead = open];\n", i, a.e[i].a[j].e, '0'+(a.e[i].a[j].c-'0')/2);
						else
							fprintf(f, "		%d -> %d [label=\"%c.5\", fontsize = 14, arrowhead = open];\n", i, a.e[i].a[j].e, '0'+(a.e[i].a[j].c-'0')/2);
					}else
						fprintf(f, "		%d -> %d [label=\"%c\", fontsize = 14, arrowhead = open];\n", i, a.e[i].a[j].e, a.e[i].a[j].c);
				}
			}
		}
	}
	
	fprintf(f, "}\n");
	fclose(f);
}

int main (int nargs, char **args)
{
	bool no0 = false;
	int i = 1;
	while(nargs > 3)
	{
		if (args[i][0] == '-')
		{
			if (strcmp(args[i], "-no0") == 0)
			{
				printf("0 interdits.\n");
				no0 = true;
			}else if (strcmp(args[i], "-nole") == 0)
			{
				printf("pas de label sur les états.\n");
				letat = false;
			}else if (strcmp(args[i], "-div2") == 0)
			{
				printf("divise par deux les labels des aretes.\n");
				div2 = true;
			}else
			{
				printf("Option %s non reconnue.\n", args[i]);
			}
		}else
			break;
		i++;
		nargs--;
	}
	if (nargs == 3)
	{
		int nb, hm;
		sscanf(args[i], "%d", &nb);
		sscanf(args[i+1], "%d", &hm);
		printf("%d balles et hauteur %d max.\n", nb, hm);
		int ne = binom(hm, nb);
		printf("%d etats.\n", ne);
		if (div2)
			printf("labels divisés par 2.\n");
		
		p = (Photo *)malloc(sizeof(Photo)*ne);
		int i;
		for (i=0;i<ne;i++)
		{
			p[i].New(hm);
		}
		a.New(ne);
		
		p[0].init(nb);
		a.e[0].New(hm);
		a.e[0].n = 0;
		np=1;
		
		for (pc=0;pc<ne;pc++)
		{
			if (p[pc].b[0])
			{
				for (i=1;i<hm;i++)
				{
					if (!p[pc].b[i])
					{
						AddP(p[pc].next(i-1), '0'+i);
					}
				}
				AddP(p[pc].next(hm-1), '0'+hm);
			}else
			{
				AddP(p[pc].next0(), '0');
			}
		}
		
		a.ef = 0;
		
		bool *s;
		if (no0)
		{
			printf("Emonde l'automate...\n");
			s = a.Emonde0();
			printf("Enregistrement de l'automate...\n");
			a.Save_FSM(s);
		}else
		{
			printf("Enregistrement de l'automate...\n");
			a.Save_FSM();
		}
		
		printf("Dessine l'automate...\n");
		if (no0)
			SaveFSM(s);
		else
			SaveFSM();
		system("dot <A.dot -Tpdf >A.pdf");
		//system("fsmcompile -iA.syms -FA.fsm <A.txt");
		//system("fsmdraw -iA.syms <A.fsm | dot -Tpdf >A.pdf");
	}else
	{
		printf("Il faut entrer le nombre de balles et la hauteur max.\n");
	}
	return 0;
}